unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  SightPt, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    SightPointRed: TSightPoint;
    SpinEditBlackX: TSpinEdit;
    SpinEditBlackY: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    SightPointBlack: TSightPoint;
    SpinEditBlackStep: TSpinEdit;
    Label3: TLabel;
    SpinEditRedX: TSpinEdit;
    Label4: TLabel;
    SpinEditRedY: TSpinEdit;
    Label5: TLabel;
    SpinEditRedStep: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    EditDist: TEdit;
    procedure SightPointRedMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SightPointRedChange(Sender: TObject; var NewX, NewY: Integer);
    procedure SpinEditBlackXChange(Sender: TObject);
    procedure SpinEditBlackYChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SightPointRedMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpinEditBlackStepChange(Sender: TObject);
    procedure SpinEditRedStepChange(Sender: TObject);
    procedure SightPointBlackChange(Sender: TObject; var NewX, NewY: Integer);
    procedure SightPointBlackMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SightPointBlackMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpinEditRedXChange(Sender: TObject);
    procedure SpinEditRedYChange(Sender: TObject);
  private
    { Private declarations }
    SavX1: Integer;
    SavY1: Integer;
    SavX2: Integer;
    SavY2: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function StrDistance : string;
var X1, Y1, X2, Y2: Integer;
    RX, RY, D: Real;
begin
with Form1.SightPointBlack do begin
  X1:=X;
  Y1:=Y;
  end;
with Form1.SightPointRed do begin
  X2:=X;
  Y2:=Y;
  end;
RX:=X1 - X2;
RY:=Y1 - Y2;
D:=Sqrt(RX*RX + RY*RY);
Result:=Format('%3f', [D]);
end;

procedure TForm1.SpinEditBlackXChange(Sender: TObject);
begin
with SightPointBlack do 
  Centre:=Point(SpinEditBlackX.Value,Centre.Y);
end;

procedure TForm1.SpinEditBlackYChange(Sender: TObject);
begin
with SightPointBlack do 
  Centre:=Point(Centre.X,SpinEditBlackY.Value);
end;

procedure TForm1.SpinEditBlackStepChange(Sender: TObject);
begin
SpinEditBlackX.Increment:=SpinEditBlackStep.Value;
SpinEditBlackY.Increment:=SpinEditBlackStep.Value;
end;

procedure TForm1.SpinEditRedXChange(Sender: TObject);
begin
SightPointRed.X:=SpinEditRedX.Value;
end;

procedure TForm1.SpinEditRedYChange(Sender: TObject);
begin
SightPointRed.Y:=SpinEditRedY.Value;
end;

procedure TForm1.SpinEditRedStepChange(Sender: TObject);
begin
SpinEditRedX.Increment:=SpinEditRedStep.Value;
SpinEditRedY.Increment:=SpinEditRedStep.Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
SpinEditBlackX.Value:=SightPointBlack.Centre.X;
SpinEditBlackY.Value:=SightPointBlack.Centre.Y;
SpinEditRedX.Value:=SightPointRed.X;
SpinEditRedY.Value:=SightPointRed.Y;
SpinEditBlackX.Increment:=SpinEditBlackStep.Value;
SpinEditBlackY.Increment:=SpinEditBlackStep.Value;
SpinEditRedX.Increment:=SpinEditRedStep.Value;
SpinEditRedY.Increment:=SpinEditRedStep.Value;
EditDist.Text:=StrDistance;
with SightPointBlack do begin
  SavX1:=Centre.X; SavY1:=Centre.Y;
  end;
with SightPointRed do begin
  SavX2:=X; SavY2:=Y;
  end;
end;

procedure TForm1.SightPointRedChange(Sender: TObject; var NewX,
  NewY: Integer);
begin
SpinEditRedX.Value:=NewX;
SpinEditRedY.Value:=NewY;
EditDist.Text:=StrDistance;
end;

procedure TForm1.SightPointRedMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssRight in Shift then begin
    SavX2:=X+SightPointRed.Left; SavY2:=Y+SightPointRed.Top;
    end
  else SightPointRed.BringToFront;
end;

procedure TForm1.SightPointRedMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var dX, dY: LongInt;
begin
if ssRight in Shift then begin
  X:=X+SightPointRed.Left; 
  Y:=Y+SightPointRed.Top;
  dX:=X-SavX2; dY:=Y-SavY2; 
  SightPointRed.X:=SightPointRed.X + dX;
  SightPointRed.Y:=SightPointRed.Y + dY;
  SavX2:=X; SavY2:=Y;
  end;
end;

procedure TForm1.SightPointBlackChange(Sender: TObject; var NewX,
  NewY: Integer);
begin
SpinEditBlackX.Value:=NewX;
SpinEditBlackY.Value:=NewY;
EditDist.Text:=StrDistance;
end;

procedure TForm1.SightPointBlackMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssRight in Shift then begin
    SavX1:=X+SightPointBlack.Left; SavY1:=Y+SightPointBlack.Top;
    end
  else SightPointBlack.BringToFront;
end;

procedure TForm1.SightPointBlackMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var dX, dY: LongInt;
begin
if ssRight in Shift then begin
  X:=X+SightPointBlack.Left; 
  Y:=Y+SightPointBlack.Top;
  dX:=X-SavX1; dY:=Y-SavY1; 
  SightPointBlack.Centre:=
    Point(SightPointBlack.Centre.X + dX,SightPointBlack.Centre.Y + dY);
  SavX1:=X; SavY1:=Y;
  end;
end;

end.
 